Require Import Relations paco.

Variables (Node: Type) (R: relation Node).

Inductive step (X: Node -> Prop) (x: Node) : Prop :=
  | step_intro : forall y, R x y -> X y -> step X x.
Hint Resolve step_intro.
Definition infpath := paco1 step bot1.

Lemma step_mon : monotone1 step.  Proof. pmonauto. Qed.
Hint Resolve step_mon : paco.

Fixpoint path n x :=match n with
    | O => True
    | S n => exists y, R x y /\ path n y
  end.

Goal 
  forall n x, infpath x -> path n x.
Proof.
  induction n; intros; simpl; auto.
  punfold H; inversion H; pclearbot; eauto.
Qed.

Goal
  forall (P: Node -> Prop),
  (forall x, P x -> exists y, clos_trans_1n _ R x y /\ P y) ->
  forall x, P x -> infpath x.
Proof.
  pcofix CIH; intros P M x Px.
  destruct (M _ Px) as (y & C & Py); clear Px.
  induction C; pfold; eauto.
Qed.
