Require Import String Arith Program.
Require Import basis vgtac lang langlemmas.
Require Import external.
Require Import simul_def.

Set Implicit Arguments.

(**********************************************
   Verification using external approach (library)
 **********************************************)

Tactic Notation "psimext_step" int_or_var(n) := 
  try left; apply (G_fold sim); simul_step n.

Lemma rfg_simulated_ext: forall n m (EQ: n = 2 * m), 
  G sim bot2 (f @ n) (g @ m).
Proof.
  pcofix CIH using (G_acc sim).
  intros; subst; do 6 psimext_step 1; do 2 psimext_step 0.
  destruct m0; psimext_step 2; [|by right; eauto].
  left; fold_rfg; generalize (m+(m+0)).
  pcofix CIH' using (G_acc sim).
  intros; do 3 psimext_step 1.
  destruct n; psimext_step 1; [by right; eauto|].
  do 3 psimext_step 1; repeat red; eauto.
Qed.
